<?php
/**
 * Project:      CMS Danneo : Content management system
 * File:         base/danneo.initapi.php
 * @version	 $Id: Danneo CMS v.0.5.4 Release $
 * @package      CMS Danneo basis kernel
 * @copyright    Copyright (C) 2004 - 2010 Danneo Team. All rights reserved.
 * @link         http://danneo.com, http://danneo.ru
 * @license      http://www.gnu.org/licenses/gpl-2.0.html   GNU General Public License, version 2
 */
if (!defined("DNREAD")) {
	exit();
}

class api
{
    var $catcache = array();
    var $catmenucache = array();
    var $subcatcache = array();
    var $keywordcache = array();
    var $print = '';
    var $sel = '';
    var $letters =
    array(
    1 => array('','rus-A'),
    2 => array('', 'rus-B'),
    3 => array('', 'rus-V'),
    4 => array('', 'rus-G'),
    5 => array('', 'rus-D'),
    6 => array('', 'rus-E'),
    7 => array('', 'rus-ZH'),
    8 => array('', 'rus-Z'),
    9 => array('', 'rus-I'),
    10 => array('', 'rus-K'),
    11 => array('', 'rus-L'),
    12 => array('', 'rus-M'),
    13 => array('', 'rus-N'),
    14 => array('', 'rus-O'),
    15 => array('', 'rus-P'),
    16 => array('', 'rus-R'),
    17 => array('', 'rus-S'),
    18 => array('', 'rus-T'),
    19 => array('', 'rus-U'),
    20 => array('', 'rus-F'),
    21 => array('', 'rus-KH'),
    22 => array('', 'rus-C'),
    23 => array('', 'rus-CH'),
    24 => array('', 'rus-SH'),
    25 => array('', 'rus-SHH'),
    26 => array('', 'rus-JE'),
    27 => array('', 'rus-JU'),
    28 => array('', 'rus-JA'),
    29 => array('0-9', 'lat-NUM'),
    30 => array('A', 'lat-A'),
    31 => array('B', 'lat-B'),
    32 => array('C', 'lat-C'),
    33 => array('D', 'lat-D'),
    34 => array('E', 'lat-E'),
    35 => array('F', 'lat-F'),
    36 => array('G', 'lat-G'),
    37 => array('H', 'lat-H'),
    38 => array('I', 'lat-I'),
    39 => array('J', 'lat-J'),
    40 => array('K', 'lat-K'),
    41 => array('L', 'lat-L'),
    42 => array('M', 'lat-M'),
    43 => array('N', 'lat-N'),
    44 => array('O', 'lat-O'),
    45 => array('P', 'lat-P'),
    46 => array('Q', 'lat-Q'),
    47 => array('R', 'lat-R'),
    48 => array('S', 'lat-S'),
    49 => array('T', 'lat-T'),
    50 => array('U', 'lat-U'),
    51 => array('V', 'lat-V'),
    52 => array('W', 'lat-W'),
    53 => array('X', 'lat-X'),
    54 => array('Y', 'lat-Y'),
    55 => array('Z', 'lat-Z')
    );

    function sitedn($resursing)
    {
        return $resursing = (preg_match("/^[a-zA-Z0-9_]+$/D",$resursing)) ? substr($resursing,0,12) : '';
    }

    function sitepa($resursing)
    {
        return $resursing = (preg_match("/^[a-zA-Z0-9_-]+$/D",$resursing)) ? substr($resursing,0,255) : '';
    }

    function siteuni($resursing)
    {
        return str_replace(
        array('&lt;','&gt;','&quot;','&#039;',
        //'&amp;',
        '\\','\'','\"'),
        array('<','>','"',"'",
        //'&',
        '',"'",'"'
        ),
        $resursing);
    }

    function sitesp($resursing)
    {
        return str_replace(array('<','>','"',"'",'&'),array('&lt;','&gt;','&quot;','&#039;','&amp;'),$resursing);
    }

    function sitedp($resursing)
    {
        return str_replace(array('&lt;','&gt;','&quot;','&#039;','&amp;','<','>','"',"'",'&'),'',$resursing);
    }

    function notfound()
    {
        if ((substr(php_sapi_name(), 0, 3)=='cgi') || isset($_SERVER['ALL_HTTP'])) {
            header('Status: 404 Not Found');
        } else {
            header('HTTP/1.0 404 Not Found');
        }
        exit();
    }

    function sitetime($gtm, $andtime = false)
    {
        global $setting,$langdate;
        $sitedate = $setting['formatdate'];
        $sitedate.= ($andtime) ? ' '.$setting['formattime'] : '';
        $gtm = $gtm - (date("Z") - (date("I") * 3600));
        $outdate = @gmdate($sitedate, $gtm + (3600 * $setting['timezone']));
        if (is_array($langdate)) {
        	$outdate = strtr(strtolower($outdate),$langdate);
        }
        return $outdate;
    }

    function timeformat($gtm, $format = false)
    {
        global $setting,$langdate;
        return gmdate("r",$gtm + (3600 * $setting['timezone']));
    }

    function findcat($id)
    {
        global $siteglobal;
        if (isset($this->catcache[$id]) && !isset($this->catmenucache[$id])) {
            $this->catmenucache[$id] = $this->catcache[$id];
            $this->findcat($this->catcache[$id]['parentid']);
        }
    }

    function findsubcat($catcache,$cid = 0)
    {
        static $c = array();
        if (!isset($catcache[$cid])){
        	return false;
        }
        foreach ($catcache[$cid] as $key => $incat){
                $c[] = $incat['catid'];
                $this->findsubcat($catcache,$incat['catid']);
        }
        unset($catcache[$cid]);
        return $c;
    }

    function sitecat($id)
    {
        global $siteglobal,$setting;
        $this->findcat($id);
        $this->catmenucache = array_reverse($this->catmenucache);
        $return = '<a href="'.$setting['site_url'].'/index.php?dn='.WORKMOD.'">'.$siteglobal['modname'].'</a>';
        foreach ($this->catmenucache as $incat) {
            $title = $this->siteuni($incat['catname']);
            $cpu = ($siteglobal['seourl'] == 1 && $incat['catcpu']) ? '&amp;cpu='.$incat['catcpu'] : '';
            $return.= ' &raquo; <a href="'.$setting['site_url'].'/index.php?dn='.WORKMOD.'&amp;to=cat&amp;id='.$incat['catid'].$cpu.'" title="'.$this->sitedp($title).'">'.$title.'</a>';
        }
        return $return;
    }

    function printsitecat($catid = 0, $depth = false)
    {
        global $setting,$nobr,$tm,$lang,$siteglobal,$api,$print,$catcount;
        if (!isset($this->subcatcache[$catid])) {
        	return false;
        }
        $stylecount = 0;
        foreach ($this->subcatcache[$catid] as $key => $val) {
            $sub = '';
            //$brcount = 0;
            static $sub;
            $stylecount++;
            $catcount++;
            $style = ($stylecount % 2 == 0) ? WORKMOD.'two' : WORKMOD.'one';
            $tic = ($val['total'] > 0) ? ' - '.$val['total'] : '';
            if ($depth > 0) {
                $subcatname = $this->siteuni($val['catname']);
                $subcpu = ($siteglobal['seourl']==1 && $val['catcpu']) ? '&amp;cpu='.$val['catcpu'] : '';
                $sub.= '<a href="'.$setting['site_url'].'/index.php?dn='.WORKMOD.'&amp;to=cat&amp;id='.$val['catid'].$subcpu.'" title="'.$subcatname.$tic.'">'.$subcatname.'</a>, ';//.(($val['total']>0) ? ' <i>['.$val['total'].']</i> ' : '').', ';
                //$brcount++;
                //if ($brcount ==3){ $brcount=0; $sub.= '<br />';}
                unset($sub,$brcount);
            }
            $this->printsitecat($val['catid'],$depth + 1);
            if ($depth == 0) {
                $catname = $this->siteuni($val['catname']);
                $cpu = ($siteglobal['seourl']==1 && $val['catcpu']) ? '&amp;cpu='.$val['catcpu'] : '';
                $title = '<a href="'.$setting['site_url'].'/index.php?dn='.WORKMOD.'&amp;to=cat&amp;id='.$val['catid'].$cpu.'" title="'.$catname.$tic.'">'.$catname.'</a>';//.(($val['total']>0) ? ' ['.$val['total'].'] ' : '');
                $icon = ($val['icon']) ? '<a href="'.$setting['site_url'].'/index.php?dn='.WORKMOD.'&amp;to=cat&amp;id='.$val['catid'].$cpu.'" title="'.$catname.$tic.'"><img src="'.$setting['site_url'].'/'.$this->siteuni($val['icon']).'" alt="'.$catname.$tic.'" /></a>' : '';
                $desc = ($val['catdesc']) ? (($nobr == 1) ? '' : '<br />').$val['catdesc'] : '';
                $sub = substr($sub,0,-2).(($sub) ? '.' : ''); //(substr($sub,-1) == '>') ? '' : substr($sub,0,-2).(($sub) ? '.' : '');
                $this->print.= $tm->parse(
                array(
                'style'=>$style,
                'icon'=>$icon,
                'title'=>$title,
                'desc'=>$desc,
                'sub'=>$sub,
                'total'=>$val['total'],
                ),
                $tm->manuale['rows']);
            }
        }
        return $this->print;
    }

    function selcat($cid = 0, $depth = 0, $catid = 0)
    {
        global $selective,$selected;
        if (!isset($this->catcache[$cid])) {
        	return false;
        }
        foreach ($this->catcache[$cid] as $key => $incat) {
            $selected = ($incat['catid'] == $catid) ? ' selected="selected"' : '';
            $indent = ($depth == 0) ? '' : str_repeat("&nbsp;&nbsp;",$depth);
            $style = ($depth == 0) ? ' class="oneselect"' : '';
            $this->sel.= '<option value="'.$incat['catid'].'"'.$style.$selected.'>'.$indent.$incat['catname'].'</option>';
            $this->selcat($incat['catid'],$depth + 1,$catid);
        }
        return $this->sel;
    }

    function mapreplace($text)
    {
        return str_replace(array("&","'","\"",">","<"),array("&amp;","&#039;","&quot;","&gt;","&lt;"),$text);
    }

    function seo($contents)
    {
        $re =
        array(
        // RSS
        "'rss.php\?dn=([a-zA-Z]*)&(amp;)?ya=1&(amp;)?id=([0-9]*)'",
        "'rss.php\?dn=([a-zA-Z]*)&(amp;)?id=([0-9]*)'",
        "'rss.php\?dn=([a-zA-Z]*)&(amp;)?ya=1'",
        "'rss.php\?dn=([a-zA-Z]*)'",
        "'sitemap.php'",
        // BANNER
        "'banner.php\?banid=([0-9]*)'",
        // ALL
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?re=comment'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=out'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=ou'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?re=rating'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=index&(amp;)?p=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=cat&(amp;)?id=([0-9]*)&(amp;)?cpu=([a-zA-Z0-9_-]*)&(amp;)?p=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=cat&(amp;)?id=([0-9]*)&(amp;)?cpu=([a-zA-Z0-9_-]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=cat&(amp;)?id=([0-9]*)&(amp;)?p=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=cat&(amp;)?id=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=dat&(amp;)?ye=([0-9]*)&(amp;)?mo=([0-9]*)&(amp;)?da=([0-9]*)&(amp;)?p=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=dat&(amp;)?ye=([0-9]*)&(amp;)?mo=([0-9]*)&(amp;)?da=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=media&(amp;)?list=([0-9]*)&(amp;)?p=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=image&(amp;)?id=([0-9]*)&(amp;)?cpu=([a-zA-Z0-9_-]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=image&(amp;)?id=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=open&(amp;)?id=([0-9]*)&(amp;)?p=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=open&(amp;)?id=([0-9]*)&(amp;)?cpu=([a-zA-Z0-9_-]*)&(amp;)?p=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=open&(amp;)?id=([0-9]*)&(amp;)?cpu=([a-zA-Z0-9_-]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=open&(amp;)?id=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=jump&(amp;)?id=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?re=load&(amp;)?cpu=([a-zA-Z0-9_-]*)&(amp;)?ds=([a-zA-Z0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?re=load&(amp;)?ds=([a-zA-Z0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?re=broken&(amp;)?id=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?re=add&(amp;)?ajax=([0-1]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?re=add'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?re=letter&(amp;)?sym=([a-zA-Z0-9-]*)&(amp;)?p=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?re=letter&(amp;)?sym=([a-zA-Z0-9-]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?re=letter'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?re=tags&(amp;)?to=tag&(amp;)?id=([0-9]*)&(amp;)?cpu=([a-zA-Z0-9_-]*)&(amp;)?p=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?re=tags&(amp;)?to=tag&(amp;)?id=([0-9]*)&(amp;)?cpu=([a-zA-Z0-9_-]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?re=tags&(amp;)?to=tag&(amp;)?id=([0-9]*)&(amp;)?p=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?re=tags&(amp;)?to=tag&(amp;)?id=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?re=tags'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=art&(amp;)?id=([0-9]*)&(amp;)?p=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=art&(amp;)?id=([0-9]*)&(amp;)?cpu=([a-zA-Z0-9_-]*)&(amp;)?p=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=art&(amp;)?id=([0-9]*)&(amp;)?cpu=([a-zA-Z0-9_-]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?to=art&(amp;)?id=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?re=search&(amp;)?id=([0-9]*)&(amp;)?p=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?re=print&(amp;)?id=([0-9]*)'",
        "'index.php\?dn=([a-zA-Z]*)&(amp;)?pa=([a-zA-Z0-9_-]*)'",
        "'index.php\?dn=([a-zA-Z]*)'",
        "'user/'" ,
        "'/([a-zA-Z]*)/comment.html&(amp;)?ajax=1&(amp;)?ct='" ,//http://katalog/shop/&to=orderconf
        "'/([a-zA-Z]+)/&(amp;)?to=([a-zA-Z0-9_-]*)'" ,
        );

        $out =
        array(
        "y\\1-\\3.rss",
        "\\1-\\3.rss",
        "y\\1.rss",
        "\\1.rss",
        "sitemap.xml",
        // BANNER
        "click-\\1.html",
        // ALL
        "\\1/comment.html",
        "\\1/out.html",
        "\\1/ou.html",
        "\\1/rating.html",
        "\\1/p-\\4.html",
        "\\1/view/\\6-\\8.html",
        "\\1/view/\\6.html",
        //"\\1/view-\\6-\\8.html",
        //"\\1/view-\\6.html",
        "\\1/r-\\4-\\6.html",
        "\\1/r-\\4.html",
        "\\1/date-\\4-\\6-\\8-\\10.html",
        "\\1/date-\\4-\\6-\\8.html",
        "\\1/media-\\4-\\6.html",
        "\\1/image/\\6.html",
        "\\1/image-\\4.html",
        "\\1/o-\\4-\\6.html",
        "\\1/open/\\6-\\8.html",
        "\\1/open/\\6.html",
        "\\1/o-\\4.html",
        "\\1/j-\\4.html",
        "\\1/load/\\4-\\6.html",
        "\\1/load/\\4.html",
        "\\1/b-\\4.html",
        "\\1/add-ajax-\\4.html",
        "\\1/add.html",
        "\\1/letter/\\4-\\6.html",
        "\\1/letter/\\4.html",
        "\\1/letter/",
        "\\1/tags/\\7-\\9.html",
        "\\1/tags/\\7.html",
        "\\1/tags/\\5-\\7.html",
        "\\1/tags/\\5.html",
        "\\1/tags/",
        "\\1/a-\\4-\\6.html",
        //"\\1/read-\\6-\\8.html",
        //"\\1/read-\\6.html",
        "\\1/read/\\6-\\8.html",
        "\\1/read/\\6.html",
        "\\1/a-\\4.html",
        "\\1/search-\\4-\\6.html",
        "\\1/print-\\4.html",
        "\\1/\\3.html",
        "\\1/",
        "index.php?dn=user",
        "/index.php?dn=\\1&re=comment&ajax=1&ct=",
		"/index.php?dn=\\1&to=\\3"
        );
        return preg_replace($re,$out,$contents);
    }

    function seokeywords($contents, $symbol = 5, $words = 35)
    {
        $contents = @preg_replace(
        array("'<[\/\!]*?[^<>]*?>'si","'([\r\n])[\s]+'si","'&[a-z0-9]{1,6};'si","'( +)'si"),
        array("","\\1 "," "," "
        ),
        strip_tags($contents));
        $rearray =
        array(
        "~","!","@","#","$","%","^","&","*","(",")","_","+",
        "`",'"',"",";",":","?","-","=","|","\"","\\","/",
        "[","]","{","}","'",",",".","<",">","\r\n","\n","\t","",""
        );
        $adjectivearray =
        array(
        "","","","","","","","","","","","","",
        "","","","","","",
        "","","","","","",
        "","","","","","",
        "","","","","","",
        "","","","","","",
        "","",""
        );
        $contents = @str_replace($rearray,' ',$contents);
        $this->keywordcache = @explode(' ',$contents);
        $rearray = array();
        foreach ($this->keywordcache as $word) {
            if (strlen($word) >= $symbol && !is_numeric($word)) {
                $adjective = substr($word,-2);
                if (!in_array($adjective,$adjectivearray) && !in_array($word,$adjectivearray)) {
                    $rearray[$word] = (array_key_exists($word,$rearray)) ? ($rearray[$word] + 1) : 1;
                }
            }
        }
        @arsort($rearray);
        $this->keywordcache = @array_slice($rearray,0,$words);
        $keywords = '';
        foreach ($this->keywordcache as $word => $count) {
            $keywords.= ','.$word;
        }
        return substr($keywords,1);
    }
}

class adv
{
    var $advcache = '';

    function banners($contents)
    {
        global $db,$basepref,$siteglobal,$setting,$tm;
        if (!is_array($this->advcache)) {
            $this->advcache = array();
            $itembanner = $db->query("SELECT * FROM ".$basepref."_banners WHERE banmods regexp '[[:<:]](".$siteglobal['dn'].")[[:>:]]' AND banlimit > banview ORDER BY MD5(RAND())");
            $arrbaner = array();
            while ($bitem = $db->fetchrow($itembanner)) {
                $arrbaner[$bitem['banzonid']] = $bitem;
            }
            if (!isset($setting['bannerzone']) || !is_array($setting['bannerzone'])) {
                $inq = $db->query("SELECT * FROM ".$basepref."_banners_zone",$setting['cachetime']);
                while ($witem = $db->fetchrow($inq,$setting['cache'])) {
                    $setting['bannerzone'][$witem['banzonid']] = $witem['banzoncode'];
                }
            }
            $in = '';
            if (isset($setting['bannerzone']) && is_array($setting['bannerzone'])) {
                foreach ($setting['bannerzone'] as $key => $item) {
                    if (isset($arrbaner[$key])) {
                        $in.= $arrbaner[$key]['banid'].',';
                        if ($arrbaner[$key]['bantype'] == 'click') {
                            $bnn = ($arrbaner[$key]['banimg']) ? '<img src="'.trim($arrbaner[$key]['banimg']).'" alt="'.$arrbaner[$key]['bantitle'].'" />' : $arrbaner[$key]['bantitle'];
                            $insert = '<a href="banner.php?banid='.$arrbaner[$key]['banid'].'" target="_blank">'.$bnn.'</a>';
                        } else {
                            $insert = (isset($arrbaner[$key]['bancode'])) ? $arrbaner[$key]['bancode'] : '';
                        }
                        $this->advcache[$item] = $insert;
                    } else {
                        $this->advcache[$item] = '';
                    }
                }
            }
            if (strlen($in) > 1) {
                $in = substr($in,0,-1);
                $db->query("UPDATE ".$basepref."_banners SET banview = banview + 1 WHERE banid IN ($in)");
            }
        }
        return $tm->parse($this->advcache,$contents);
    }
}

class db
{
    var $connid = 0;
    var $result;
    var $errormsg;
    var $sqlcount = 0;
    var $filecount = 0;
    var $totaltime = 0;
    var $works = 0;
    var $explain = '';
    var $save = '';
    var $cache = array('fields'=>array(),'data'=>array());
    var $file = '';
    var $initcache = true;
    var $incache = '';

    function dbtime()
    {
        list($usec,$sec) = explode(' ', microtime());
        return ((float)$usec + (float)$sec);
    }

    function db($server, $user, $password, $database)
    {
        global $setting;
        $this->server = $server;
        $this->user = $user;
        $this->password = $password;
        $this->database = $database;
        $start = $this->dbtime();
        if ($this->connid == 0) {
            if (empty($password)) {
                $this->connid = @mysql_connect($server, $user);
            } else {
                $this->connid = @mysql_connect($server, $user, $password);
            }
            if ($this->connid) {
                if ($database) {
                    if (@mysql_select_db($database, $this->connid)) {
                        $this->totaltime += sprintf('%.5f', $this->dbtime() - $start);
                    } else {
                        $this->errormsg = 'Not selected DB !     !';
                        $this->error();
                    }
                } else {
                    $this->errormsg = 'Not selected DB !     !';
                    $this->error();
                }
            } else {
                $this->errormsg = 'Not connect server !      !';
                $this->error();
            }
        }
    }

    function escape($query)
    {
        return @mysql_real_escape_string($query);
    }

    function cachewrite($cacheresult)
    {
        $cachefile = @fopen($this->file,'w+');
        if ($cachefile) {
            @fwrite($cachefile, $cacheresult);
            @fclose($cachefile);
        }
    }

    function query($query = '', $time = false, $in = '')
    {
        global $setting;
        $setting['debug'] = (isset($setting['debug'])) ? $setting['debug'] : 'no';
        $this->result = $write = '';
        $nodb = 1;
        $start = $this->dbtime();
        if ($query) {
            if ($time == false || $setting['cache'] == 0) {
                $this->result = @mysql_query($query,$this->connid);
                $this->initcache = false;
            } else {
                $this->file = DNBASE.'cache/sql/'.((empty($in)) ? '' : $in.'/').md5($query).'.txt';
                if (($file = @file_get_contents($this->file)) && @filemtime($this->file) > (time() - $time)) {
                    $this->result = unserialize($file);
                    $nodb = 0;
                    if (empty($this->result)) {
                        $this->initcache = false;
                        $nodb = 1;
                        $this->result = @mysql_query($query,$this->connid);
                    }
                } else {
                    $this->result = @mysql_query($query,$this->connid);
                    $resurse = array();
                    while ($insert = $this->fetchrow($this->result,0)) {
                    	@array_push($resurse,$insert);
                    }
                    $write = @serialize($resurse);
                    $this->cachewrite($write);
                    $this->result = $resurse;
                }
            }
        }
        if ($this->result) {
            if ($setting['debug'] == 'yes') {
                $this->totaltime += sprintf('%.5f',$this->dbtime() - $start);
                $this->explain.= ($nodb == 1) ? '<li>QUERY : <p>EXPLAIN '.$query.'</p><span>'.sprintf('%.5f',$this->dbtime() - $start).'</span></li>' : '<li>READ : <p>file '.md5($query).'.txt</p><span>'.sprintf('%.5f',$this->dbtime() - $start).'</span></li>';
            }
            if ($nodb == 1) {
            	++$this->sqlcount;
            } else {
            	++$this->filecount;
            }
            return $this->result;
        } else {
            if($setting['debug'] == 'yes' && $nodb == 0) {
            	$this->errormsg = $query;
            	$this->error();
            } else {
            	false;
            }
        }
    }

    function numrows($query = 0, $cache = false)
    {
        if ($cache && $this->initcache == true) {
            return @sizeof($this->result);
        } else {
            return @mysql_num_rows($query);
        }
    }

    function fetchrow($query = 0,$cache = false)
    {
        if ($cache && $this->initcache == true) {
            @list($key, $re) = @each($this->result);
            return $re;
        } else {
            return @mysql_fetch_array($query);
        }
    }

    function freerow($query = 0)
    {
    	return @mysql_free_result($query);
    }

    function numfields($query = 0)
    {
    	return @mysql_num_fields($query);
    }

    function fieldname($offset, $query = 0)
    {
    	return @mysql_field_name($query, $offset);
    }

    function insertid()
    {
    	return @mysql_insert_id($this->connid);
    }

    function affrows()
    {
    	return @mysql_affected_rows($this->connid);
    }

    function geterrdesc()
    {
    	return $this->error = mysql_error();
    }

    function geterrno()
    {
    	return $this->errno = mysql_errno();
    }

    function error()
    {
        global $setting;
        $langcharset = (isset($setting['langcharset'])) ? $setting['langcharset'] : 'windows-1251';
        echo '<HTML>'
             .'<HEAD>'
             .'<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset='.$langcharset.'">'
             .'<TITLE>MySQL Debugging</TITLE>'
             .'</HEAD>'
             .'<div align="left" style="border:1px solid #999; font-size:11px; font-family:tahoma,verdana,arial; background-color:#f3f3f3; color:#A73C3C; margin:5px; padding:5px;">'
             .'<div align="left" style="border:1px solid #999; font-size:11px; background-color:#f9f9f9; color:#666; margin:0px; padding:5px;">'
             .'<strong>MySQL Debugging</strong></div><br />'
             .'<li><b>SQL.q :</b> <div style="color:#888;">' . $this->errormsg . '</div></li>'
             .'<li><b>MySQL.e :</b> <div style="color:#888;">' . $this->geterrdesc() . '</div></li>'
             .'<li><b>MySQL.e. :</b> <div style="color:#888;">' . $this->geterrno() . '</div></li>'
             .'<li><b>PHP.v :</b> <div style="color:#888;">' . phpversion() . '</div></li>'
             .'<li><b>Data :</b> <div style="color:#888;">' . date("d.m.Y H:i") . '</div></li>'
             .'<li><b>Script :</b> <div style="color:#888;">' . getenv("REQUEST_URI") . '</div></li>'
             .'<li><b>Refer :</b> <div style="color:#888;">' . getenv("HTTP_REFERER") . '</li></div>'
             .'</BODY>'
             .'</HTML>';
        exit();
    }

    function close()
    {
    	if ($this->connid) {
    		if ($this->result){
    			@mysql_free_result($this->result);
    		}
    		return @mysql_close($this->connid);
    	}
    }
}
?>